% script to make header file of J_0 zeros.
%
% barnett 11/27/02

% how many zeros to do
n = 1000;
% order
nu = 0;

z = zeros(1,n);
j1 = zeros(1,n);
for i=1:n
  % estimate i_th zero
  beta = (i + 0.5*nu - 0.25)*pi;
  mu = 4*nu^2;
  z_est = beta - (mu-1)/(8*beta) - 4*(mu-1)*(7*mu-31)/(3*(8* ...
						  beta)^3);
  
  %z_est = (i - 0.25 + 0.5*nu)*pi;
  %j0([z_est-0.01/i^4,z_est,z_est+0.01/i^4])

  dz = 0.01; % 0.01/i^4 gets too small!
  
  % required wrapper j0 around besselj so first (and only) arg is x...
  z(i) = fzero('j0', [z_est-dz,z_est+dz]);
  j1(i) = besselj(1, z(i));
end

% write out file
fid = fopen('j0.h', 'w');
fprintf(fid, '#define MAX_MODES %d\n\n', n);
fprintf(fid, 'static double J0_ZEROS[] = {\n');
for i=1:n-1
  fprintf(fid, '\t%.18g,\n', z(i));
end
fprintf(fid, '\t%.18g\n};\n\n', z(n));
fprintf(fid, 'static double J1_AT_J0_ZEROS[] = {\n');
for i=1:n-1
  fprintf(fid, '\t%.18g,\n', j1(i));
end
fprintf(fid, '\t%.18g\n};\n', j1(n));
fclose(fid);

% end
