% SLA figure fixed beta test SYS1-4

% units mm, ps.
c = 0.2997;
dz = 10;
musps = [0.3 3; 3 0.3; 0.3 3; 3 0.3];   % SYS2-5
muas = [0 0.03; 0 0.03; 0.03 0; 0.03 0];
%musps = [0.5 2; 2 0.5; 0.5 2; 2 0.5];   % SYS2-5
%muas = [0 0.03; 0 0.03; 0.03 0; 0.03 0];
%dz = [4 7 2 3 1 5 20];
%musps = [0.5 2 2 0.5 0.5 2 2 0.5];
%muas = [0 0.03 0 0.03 0.03 0 0.03 0];
ns = size(musps,1);
n = 1.4;
v = c/n;

% time-gates
tmin=100;  %100   % earlier = slower runtime of slab.c
tmax=3000;
dtgate=2.9;  % dtgate=100;
% set up resampled t array for matlab display...
ntgate=(tmax-tmin)/dtgate + 1;
sigt = tmin + dtgate*((1:ntgate)' - 1);

err_zbox = 1e-6;
err_h = -0.5;
err_lbox = 1e-6;
err_trunc = 1e-12;
scheme = 4;
  % CN var
bcs = 1;  % EBC

% error measure params... gamma, epsilon
g = 1e5;
e = 1e-2;

% sample radii, beta...
R = [0 20 40];
b = 0.04;

nr = length(R);

figure;
for is = 1:ns
  sigb = slab(tmin,tmax,dtgate,R,muas(is,:),musps(is,:),dz,n,...
	      [err_zbox,err_h,-b,err_lbox,err_trunc,...
	       -1,129,scheme,bcs]); %129
  sige =  slab(tmin,tmax,dtgate,R,muas(is,:),musps(is,:),dz,n,...
	       [err_zbox,err_h,-0.5,err_lbox,err_trunc,...
		-1,129,3,bcs]); % CN const, choose dt = 0.25

  sige = abs(sige);
  peak = repmat(max(sige), [ntgate 1]);  % matrix for multiple R
  errb = e*sige;
  % fixed relative error size 
  % poisson-noise type cutoff of dyn range...
  errb = max(sqrt(g*sige./peak).*(peak/g), errb);
  errb = max(peak/g, errb); %   hard dynamic range cutoff

  lt = ['k: ';'k- ';'k--'];

  subplot(ns,1,is);
  for r=1:nr
    if r==2
      hold on;
    end
    semilogy(sigt,abs(sigb(:,r)-sige(:,r))./errb(:,r), lt(r,:));
  end
  hold off;
  hline(1,'r-');
  set(gca,'FontSize',16);
  text(0.6,0.85,sprintf('SYS%d',is+1),'units','normalized','fontsize',16);
  axis([0 tmax 1e-2 1e2]);
  legnum(R, 2, 'R=');
  if (is==ns)
    xlabel('t (ps)');
  end
  ylabel('E(t)');
end

%print -depsc2 /home/alex/dot/mls/sla/fig/dtsys_1.eps


