% SLA figure modes.

% units mm, ps.
c = 0.2997;
mua = [0.01 0.01];
musp = [1.0 1.0];
dz = 10;
n = 1.4;
v = c/n;

% time-gates
tmin=200;  %100   % earlier = slower runtime of slab.c
tmax=3000;
dtgate=20;  % dtgate=100;
% set up resampled t array for matlab display...
ntgate=(tmax-tmin)/dtgate + 1;
sigt = tmin + dtgate*((1:ntgate)' - 1);
R = 40;

err_zbox = 1e-6;
err_h = -0.5;
err_dt = -0.1;  % beta
err_lbox = 1e-6;
err_trunc = 1e-9;
scheme = 4;  % CN var
bcs = 1;  % EBC

N_m = 100; % can exceed N_m given by code - simply returns zeros

sigs = zeros(length(sigt), N_m);
for m=1:N_m
  sigs(:,m) = slab(tmin,tmax,dtgate,R,mua,musp,dz,n,...
	[err_zbox,err_h,err_dt,err_lbox,err_trunc,m,3*(m==1),scheme,bcs]);
end
sigte = 50:50:tmax+tmin;   % for exact plot
sige = homog(sigte, mua(1), musp(1), v, R, bcs);

figure;
semilogy(sigte,sige,'--', repmat(sigt,[1,N_m]),abs(sigs),'-');
set(gca,'FontSize',16);
axis([0 tmax+tmin 1e-25 1e-6]);
hold on;
ph = plot(sigt,abs(sum(sigs,2)),'k.');
set(ph, 'MarkerSize', 15);
%title('2A: 3d, contribs from modes');
hold off;
xlabel('t (ps)');
ylabel('I(R,t)');

% compile slab.c consistent
%print -depsc2 /home/alex/dot/mls/sla/fig/modes_1.eps
% compile slab.c inconsistent
%print -depsc2 /home/alex/dot/mls/sla/fig/modes_2.eps
