% Tualle comparison plot for SLA paper.


% 2-layer, n=1.4, extrap BCs, det gradient - since Tualle does this.
tmin = 100;
tmax = 3000;
dtgate = 5.7;
ntgate=floor((tmax-tmin)/dtgate + 1);
sigt = tmin + dtgate*((1:ntgate)' - 1);
system(sprintf('/home/alex/dot/tualle/tu 1 %g %g %g 5 0 10 20 30 40 0.01 0.003 0.5 2.0 10 1.4 1.4 2 20 tl_2_15.sig',tmin,dtgate,ntgate));
sige = reshape(load('tl_2_15.sig'), [ntgate 5]);
% tualle 2-layer slab
R = [0 10 20 30 40];
scheme = 4;
% barnett 2-layer slab
sigb = slab(tmin,tmax,dtgate,R,[0.01 0.003],[0.5 2.0],[10],1.4,...
	   [1e-6,0.01,-0.05,1e-6,1e-12,-1,129,scheme,2]);

% rescale tualle to have same value as R=40 latest time...
ratios = sigb(ntgate,5)./sige(ntgate,5);
sige = sige*ratios;

% normalize peaks...
peak = repmat(max(sige), [ntgate 1]);  % matrix for multiple R
sige = sige./peak;
sigb = sigb./peak;

% attempt to redo order of linetypes for b/w - too permanent!
%set(0,'defaultaxescolororder',[0 0 0; 0.4 0.4 0.4], ...
%      'defaultaxeslinestyleorder','-|--|:');

figure;
% your basic overplotting, linear scale...
% axes('position',[0.1 0.4 0.8 0.5]);
ts = 1:5:ntgate;    % times to sample.
set(gca,'fontsize',16);
plot(sigt,sige,'k-');
hold on;
mt = 'o.+x*';
for r=1:5
  h(r) = plot(sigt(ts),sigb(ts,r),mt(r),'color',[0 0 0]);
end
hold off;
legend(h,{'R = 0 mm','R = 10 mm','R = 20 mm','R = 30 mm','R = 40 mm'});
xlabel('t (ps)');
ylabel('I(t)');
axis([0 2000 0 1.05]);

print -depsc2 /home/alex/dot/mls/sla/fig/tualle_lin.eps

% .........................................................................
% error measure params... gamma, epsilon
g = 1e5;
e = 1e-2;

% set error levels
peak = repmat(max(sige), [ntgate 1]);  % matrix for multiple R
errb = e*sige;  % fixed relative error size 
% poisson-noise type cutoff of dyn range...
errb = max(sqrt(g*sige./peak).*(peak/g), errb);
errb = max(peak/g, errb); %   hard dynamic range cutoff

%axes('position',[0.1 0.1 0.8 0.2]);
figure;
axes('position',[0.1 0.1 0.8 0.3]);
lt = ['k: ';'k- ';'k--'; 'k-.'; '.k-'];
for r=1:5
  if r==2
    hold on;
  end
  semilogy(sigt,abs(sigb(:,r)-sige(:,r))./errb(:,r), lt(r,:));
end
hold off;
set(gca,'FontSize',16);
legnum(R, 2, 'R=');
hline(1,'r-');
axis([0 tmax 1e-2 1e1]);
xlabel('t (ps)');
ylabel('E(t)');
print -depsc2 /home/alex/dot/mls/sla/fig/tualle_err.eps
